unit Demo_Client;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ImgList, StdCtrls, Buttons, ExtCtrls, ComCtrls, SoLAccessManager,
  SoLSharedMemFile, ShellAPI;
type
  TForm1 = class(TForm)
    Lv: TListView;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    LSenderTitle: TLabel;
    LSenderExeName: TLabel;
    LMemFileTransferMode: TLabel;
    LMemFileRecordSize: TLabel;
    LMemFileRecordCount: TLabel;
    ImageList1: TImageList;
    SoLMemDataSharing1: TSoLMemDataSharing;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    LMemFileSize: TLabel;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    Label17: TLabel;
    Label18: TLabel;
    LSenderExtraInfo: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    LSenderUID: TLabel;
    LMemFileExtraInfo: TLabel;
    Label24: TLabel;
    LMemFileName: TLabel;
    StaticText3: TStaticText;
    SpeedButton2: TSpeedButton;
    SpeedButton1: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure SoLMemDataSharing1DataReady(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    function ExecuteFile(const FileName, Params, DefaultDir: string; ShowCmd: Integer): THandle;
    { Dclarations prives }
  public
    { Dclarations publiques }
    procedure HandleMessages(var Msg: TMsg; var Handled: Boolean);

  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
Application.OnMessage := HandleMessages;
end;

procedure TForm1.HandleMessages(var Msg: TMsg; var Handled: Boolean);
begin
  SoLMemDataSharing1.HandleMessages(Msg, Handled);
end;

procedure TForm1.SoLMemDataSharing1DataReady(Sender: TObject);
Type
TRecord = record
    ImageCaption, Info, ExtraInfo : string[150];
    ImageIndex: Integer;
    end;

var
R: ^TRecord;
L: TList;
LItem: TListItem;
i: Integer;

begin
L := TList.Create;
SoLMemDataSharing1.ReadData(L);
// Fill the Listview
for i := 0 to L.Count -1 do
    begin
    R := L.Items[i];
    LItem := Lv.Items.Add;
    LItem.ImageIndex := R^.ImageIndex;
    LItem.Caption := R^.ImageCaption;
    LItem.SubItems.Add(R^.Info);
    LItem.SubItems.Add(R^.ExtraInfo);
    LItem.ImageIndex := R^.ImageIndex;
    end;
// Show information
With SoLMemDataSharing1 do
begin
LSenderTitle.Caption := SoLMemDataSharing1.CurrentApplication.Title;
LSenderExeName.Caption := SoLMemDataSharing1.CurrentApplication.ExeName;
LSenderExtraInfo.Caption := SoLMemDataSharing1.CurrentApplication.ExtraInfo;
LSenderUID.Caption := SoLMemDataSharing1.CurrentApplication.UID;
LMemFileName.Caption := SoLMemDataSharing1.MemoryFile.Name;
LMemFileExtraInfo.Caption := SoLMemDataSharing1.MemoryFile.ExtraInfo;
LMemFileSize.Caption := IntToStr(SoLMemDataSharing1.MemoryFile.Size);
LMemFileRecordSize.Caption := IntToStr(SoLMemDataSharing1.MemoryFile.RecordSize);
LMemFileRecordCount.Caption := IntToStr(SoLMemDataSharing1.MemoryFile.RecordCount);
case MemoryFile.TransferMode of
     sdSynchronize : LMemFileTransferMode.Caption := 'sdSynchronize';
     sdAppend : LMemFileTransferMode.Caption := 'sdAppend';
     sdAppendUpdate : LMemFileTransferMode.Caption := 'sdAppendUpdate';
     sdCopy : LMemFileTransferMode.Caption := 'sdCopy';
     sdDelete : LMemFileTransferMode.Caption := 'sdDelete';
     end;
end;
L.Free;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
Lv.Items.Clear;
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
ExecuteFile('http://source.online.free.fr','', '', SW_SHOW);
end;

function TForm1.ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..250] of Char;
begin
    Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), ShowCmd);
end;

end.
