unit Demo_Server;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ImgList, ExtCtrls, Buttons, SoLAccessManager, Menus,
  ActnList, ShellAPI, Registry, StdActns, SoLSharedMemFile;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    tsTSoLMemDataSharing: TTabSheet;
    tsTSoLAccessManager: TTabSheet;
    Lv: TListView;
    ImageList1: TImageList;
    Panel1: TPanel;
    btSendData: TBitBtn;
    Label1: TLabel;
    Panel2: TPanel;
    Image1: TImage;
    ImageCaption: TEdit;
    Information: TEdit;
    ExtraInformation: TEdit;
    sbAdd: TSpeedButton;
    sbDelete: TSpeedButton;
    sbReplace: TSpeedButton;
    sbNext: TSpeedButton;
    sbPrevious: TSpeedButton;
    ActionList: TActionList;
    Panel3: TPanel;
    Label2: TLabel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Bevel1: TBevel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Image2: TImage;
    Image3: TImage;
    Label3: TLabel;
    Image4: TImage;
    Label4: TLabel;
    Label5: TLabel;
    Action1: TAction;
    Action2: TAction;
    Action3: TAction;
    Action4: TAction;
    Action5: TAction;
    Action6: TAction;
    Action7: TAction;
    Action8: TAction;
    tsIndex: TTabSheet;
    Image5: TImage;
    Image6: TImage;
    Label6: TLabel;
    Label7: TLabel;
    PopupMenu1: TPopupMenu;
    Action11: TMenuItem;
    Action21: TMenuItem;
    Action31: TMenuItem;
    Action41: TMenuItem;
    Action51: TMenuItem;
    Action61: TMenuItem;
    Action71: TMenuItem;
    Action81: TMenuItem;
    SoLMemDataSharing1: TSoLMemDataSharing;
    SoLAccessManager1: TSoLAccessManager;
    SoLActionList1: TSoLActionList;
    procedure sbAddClick(Sender: TObject);
    procedure btSendDataClick(Sender: TObject);
    procedure sbNextClick(Sender: TObject);
    procedure sbPreviousClick(Sender: TObject);
    procedure LvSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure sbReplaceClick(Sender: TObject);
    procedure sbDeleteClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure tsTSoLAccessManagerShow(Sender: TObject);
    procedure SpeedButton3MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Action1Execute(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure SoLAccessManager1DataReady(Sender: TObject);
  private
    { Dclarations prives }
    procedure HandleMessages(var Msg: TMsg; var Handled: Boolean);
    procedure DrawImage(Sender: TObject);
    function ExecuteFile(const FileName, Params, DefaultDir: string; ShowCmd: Integer): THandle;
    procedure showMenu;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;
  CurrentImage: Integer;
implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
Application.OnMessage := HandleMessages;
PageControl1.ActivePage := tsIndex;
Lv.Selected := Lv.Items[0];
end;

procedure TForm1.HandleMessages(var Msg: TMsg; var Handled: Boolean);
begin
  SoLAccessManager1.HandleMessages(Msg, Handled);
end;

procedure TForm1.LvSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
CurrentImage := Item.ImageIndex;
ImageCaption.Text := Item.Caption;
Information.Text := Item.SubItems[0];
ExtraInformation.Text := Item.SubItems[1];
DrawImage(Sender);
sbReplace.enabled := True;
end;

procedure TForm1.sbAddClick(Sender: TObject);
var
ListItem: TListItem;
begin
ListItem := Lv.Items.Add;
ListItem.ImageIndex := CurrentImage;
ListItem.Caption := ImageCaption.Text;
ListItem.SubItems.Add(Information.Text);
ListItem.SubItems.Add(ExtraInformation.Text);
sbDelete.Enabled := (Lv.Items.count > 0);
sbReplace.Enabled := (Lv.Selected <> nil);
end;

procedure TForm1.sbReplaceClick(Sender: TObject);
begin
if (Lv.Selected <> nil) then
begin
with Lv.Selected do
  begin
  ImageIndex := CurrentImage;
  Caption := ImageCaption.Text;
  SubItems.Strings[0] := Information.Text;
  SubItems.Strings[1] := ExtraInformation.Text;
  end;
end;
end;

procedure TForm1.sbDeleteClick(Sender: TObject);
begin
if Lv.Items.count > 0
   then begin
        Lv.Selected.Delete;
        Lv.Selected := Lv.Items[0];
        end;
sbDelete.Enabled := (Lv.Items.count > 0);
sbReplace.Enabled := (Lv.Selected <> nil);
end;

procedure TForm1.sbPreviousClick(Sender: TObject);
begin
if (CurrentImage > 0)
   then begin
        dec(CurrentImage);
        DrawImage(Sender);
        end;
end;

procedure TForm1.sbNextClick(Sender: TObject);
begin
if CurrentImage < (Imagelist1.Count - 1)
   then begin
        inc(CurrentImage);
        DrawImage(Sender);
        end;
end;

procedure TForm1.DrawImage(Sender: TObject);
begin
Image1.Picture := nil;
ImageList1.GetBitmap(CurrentImage,Image1.Picture.Bitmap);
sbNext.visible := (CurrentImage < (Imagelist1.Count - 1));
sbPrevious.visible := (CurrentImage > 0);
Image1.Repaint;
end;


procedure TForm1.btSendDataClick(Sender: TObject);
Type
TRecord = record
    ImageCaption, Info, ExtraInfo : string[150];
    ImageIndex: Integer;
    end;

var
R: ^TRecord;
L: TList;
i: Integer;
begin
L := TList.Create;
for i := 0 to Lv.Items.count - 1 do
    begin
    New(R);
    R^.ImageCaption := Lv.Items[i].Caption;
    R^.Info := Lv.Items[i].SubItems[0];
    R^.ExtraInfo := Lv.Items[i].SubItems[1];
    R^.ImageIndex := Lv.Items[i].ImageIndex;
    L.Add(R);
    end;
SoLMemDataSharing1.CurrentApplication.ExeName := Application.ExeName;
SoLMemDataSharing1.CurrentApplication.Title := Application.Title;
SoLMemDataSharing1.CurrentApplication.ExtraInfo := 'TSoLMemDataSharing version 0.5';
SoLMemDataSharing1.CurrentApplication.UID := 'UID not used by this demo';
SoLMemDataSharing1.MemoryFile.RecordSize := SizeOf(TRecord);
SoLMemDataSharing1.MemoryFile.ExtraInfo := 'You may add extra info here...';
SoLMemDataSharing1.TargetApplication.Name := 'Client_Demo';
SoLMemDataSharing1.SendData(L);
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
ExecuteFile('http://www.torry.net','', '', SW_SHOW);
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
ExecuteFile('http://source.online.free.fr','', '', SW_SHOW);
end;

function TForm1.ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..250] of Char;
begin
    Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), ShowCmd);
end;

procedure TForm1.tsTSoLAccessManagerShow(Sender: TObject);
var
Registry : TRegistry;
begin
Registry:=TRegistry.Create;
Try
  Registry.RootKey:=HKEY_LOCAL_MACHINE;
  if not Registry.KeyExists('\Software\SoL Software\SoL Manager\Directories')
     then Application.MessageBox(PChar('SoL Manager was not detected on your system. This demo works only with SoL Manager properly installed...'),
          PChar('SoL Manager not found'),IDOK);
finally
Registry.Free;
end;
showMenu;
end;

procedure TForm1.SpeedButton3MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
showMenu;
end;

procedure TForm1.ShowMenu;
var
P: TPoint;
begin
P.x := SpeedButton3.Left-296;
P.y := SpeedButton3.Top+10;
P := SpeedButton3.ClientToScreen(P);
PopupMenu1.Popup(P.x,P.y);
end;


procedure TForm1.Action1Execute(Sender: TObject);
begin
//Dummy
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
SoLAccessManager1.SendActionListData;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
SoLAccessManager1.RequestData(-1);
Application.MessageBox('Look at [SoL Manager] to set the menu items', 'Info...', MB_OK);
end;


procedure TForm1.SoLAccessManager1DataReady(Sender: TObject);
begin
SoLAccessManager1.GetUserAccess;
end;

end.
