(******* SoL - Open Source Project - http://source.online.free.fr  ***********
This history file header is part of the SoLAccessManager.pas file and
shall be kept with the code. This unit is provided "as is"
with no warranty of any kind, that means you can freely use
it but at your own risk, in respect with the Gnu GPL license agreement.
(Read the licence.html file for further information)
=========================================================================
| Version | status  |   date    |        by         |        e mail
-------------------------------------------------------------------------
   0.01     Created    08/2002       Luc DAVID         lucdavid@online.fr
   0.02     Modified   11/2002       Luc DAVID         lucdavid@online.fr
=========================================================================*)

{$IFDEF VER120}      // Delphi 4.0
  {$DEFINE Delphi4}
{$ENDIF}

{$IFDEF VER130}      // Delphi 5.0
  {$DEFINE Delphi4}
{$ENDIF}

{$IFDEF VER140}      // Delphi 6.0
  {$DEFINE Delphi6}
{$ENDIF}

unit SoLAccessManagerReg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls, ToolWin,
 {$IFNDEF Delphi6}DsgnIntf,{$ENDIF}
 {$IFDEF Delphi6}DesignIntf, DesignEditors,{$ENDIF}
  SoLSharedMemFile, SoLAccessManager, Menus, ImgList, ActnList, Consts;

{$IFDEF Delphi6}
type
  TDesigner = DesignIntf.IDesigner;
  TFormDesigner = DesignIntf.IDesigner;
{$ELSE}
type
  TDesigner = IDesigner;
  TFormDesigner = IFormDesigner;
{$ENDIF}
  
type
  TSoLActionsEditor = class(TForm)
    ToolBar1: TToolBar;
    tbNew: TToolButton;
    tbDelete: TToolButton;
    tbLoadFrom: TToolButton;
    lbCategories: TListBox;
    Splitter1: TSplitter;
    lbActions: TListBox;
    ImageList1: TImageList;
    tbUp: TToolButton;
    tbDown: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    MenuLoadFrom: TPopupMenu;
    ActionList1: TActionList;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Action1: TAction;
    MenuItem0: TMenuItem;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    procedure tbNewClick(Sender: TObject);
    procedure lbActionsClick(Sender: TObject);
    procedure tbDeleteClick(Sender: TObject);
    procedure tbUpClick(Sender: TObject);
    procedure tbDownClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure lbCategoriesClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MenuItemClick(Sender: TObject);
  protected
    procedure UpdateSpeedBar;
    procedure SetMenuLoadFromItems;
  public
    FSoLActionList: TSoLActionList;
    TheDesigner: TFormDesigner;
    procedure RefreshActionsList;
    procedure RefreshCategoriesList;
  end;

var
  SoLActionsEditor: TSoLActionsEditor;

procedure Register;

implementation

{$R *.DFM}

// custom editor for TSoLActionList --------------------------------------
type
  TSoLActionListEditor = class(TComponentEditor)
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
    procedure ShowSoLActionListEditor(Designer: TDesigner; SoLActionList: TSoLActionList);
  end;

  TSoLTargetNameEditor = class(TStringProperty)
    Public
      Procedure Edit;override;
      Procedure SetValue(const Value: string); override;
      Function  GetAttributes: TPropertyAttributes; override;
    End;

// custom editor for TSoLAccessManager-------------------------------------
  TSoLAccessManagerEditor = class(TComponentEditor)
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
    procedure ShowSoLAccessManagerEditor;
    end;

procedure Register;
begin
  RegisterNoIcon([TSoLAction]);
  RegisterComponents('SoL', [TSoLAccessManager, TSoLActionList, TSoLMemDataSharing]);
  RegisterComponentEditor(TSoLActionList, TSoLActionListEditor);
  RegisterComponentEditor(TSoLAccessManager, TSoLAccessManagerEditor);
  RegisterPropertyEditor(TypeInfo(String) ,TSoLTargetApplication,'Path',TSoLTargetNameEditor);
end;

// SoLActionListEditor --------------------------------------------------------
procedure TSoLActionListEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0 : ShowSoLActionListEditor(Designer, TSoLActionList(Component));
  end;
end;

function TSoLActionListEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := '&SoL Actions Manager...';
   end;
end;

function TSoLActionListEditor.GetVerbCount: Integer;
begin
  Result := 1
end;

// SoLAccessManagerEditor --------------------------------------------------------
procedure TSoLAccessManagerEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0 : ShowSoLAccessManagerEditor;
  end;
end;

function TSoLAccessManagerEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := '&Show linked SoL ActionList(s)...';
   end;
end;

function TSoLAccessManagerEditor.GetVerbCount: Integer;
begin
  Result := 1
end;

// Utility routines -----------------------------------------------------------------------------
function FindEditor(SoLActionList: TSoLActionList): TSoLActionsEditor;
var
  I: Integer;
begin
  Result := nil;
  for I := 0 to Screen.FormCount - 1 do begin
    if Screen.Forms[I] is TSoLActionsEditor then begin
      if TSoLActionsEditor(Screen.Forms[I]).FSoLActionList = SoLActionList then
      begin
        Result := TSoLActionsEditor(Screen.Forms[I]);
        Break;
      end;
    end;
  end;
end;

function FindActionList(ComponentName: String): TActionList;
var
  i,j: Integer;
  C: TComponent;
begin
  Result := nil;
  for i := 0 to Screen.FormCount - 1 do begin
   for j := 0 to Screen.Forms[i].ComponentCount - 1 do begin
    C := Screen.Forms[i].Components[j];
    if (C.Owner.Name + '.' + C.Name = ComponentName)
        and (C is TActionList)
        and (C.ComponentState = [csDesigning]) then
        begin
        Result := C as TActionList;
        Break;
        end;
   end;
  end;
end;

// SoLActionListEditor Editor -----------------------------------------------------------------------------
procedure TSoLActionListEditor.ShowSoLActionListEditor(Designer: TDesigner; SoLActionList: TSoLActionList);
begin
  if SoLActionList = nil then exit;
  SoLActionsEditor :=  FindEditor(SolActionList);

if SoLActionsEditor <> nil
    then begin
    SoLActionsEditor.Show;
    if SoLActionsEditor.WindowState = wsMinimized then SoLActionsEditor.WindowState := wsNormal;
    end
    else begin
    SoLActionsEditor := TSoLActionsEditor.Create(Application);
    try
      SoLActionsEditor.FSoLActionList := SoLActionList;
      SoLActionList.FEditorHwnd := SoLActionsEditor.Handle;
      SoLActionsEditor.UpdateSpeedBar;
    except
      SoLActionsEditor.Free;
      raise;
    end;
    end;

  with SoLActionsEditor do
    begin
    TheDesigner := Self.Designer;  //Don't forget SELF !!
    {$IFDEF Delphi6}
    Caption := TheDesigner.Root.Name + '.' + TSoLActionList(Component).Name;//'SoL Actions Editor';
    {$ELSE}
    Caption := TheDesigner.Form.Name + '.' + TSoLActionList(Component).Name;//'SoL Actions Editor';
    {$ENDIF}
    SoLActionsEditor.Show;
  end;
end;

procedure TSoLActionsEditor.SetMenuLoadFromItems;
var
a,i,j: Integer;
begin
a := 0;
for i := 0 to Screen.FormCount - 1 do
 for j := 0 to Screen.Forms[i].ComponentCount - 1 do
    if (Screen.Forms[i].ComponentState = [csDesigning]) and (Screen.Forms[i].Components[j] is TActionList) and (a < 9)
         then begin
         {$IFDEF Delphi6}
         if Screen.Forms[i] = TheDesigner.Root
         {$ELSE}
         if Screen.Forms[i] = TheDesigner.Form
         {$ENDIF}
            then MenuLoadFrom.Items[a].Caption := Screen.Forms[i].Components[j].Name
            Else MenuLoadFrom.Items[a].Caption := Screen.Forms[i].Name + '.' + Screen.Forms[i].Components[j].Name;
          MenuLoadFrom.Items[a].Visible := True;
          inc(a);
          end;
end;

procedure TSoLActionsEditor.FormActivate(Sender: TObject);
begin
SetMenuLoadFromItems;
RefreshActionsList;
end;

procedure TSoLActionsEditor.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
FSoLActionList := nil;
Free;
end;

// Actions and Categories ListBoxes -----------------------------------------------
procedure TSoLActionsEditor.lbCategoriesClick(Sender: TObject);
begin
RefreshActionsList;
end;

procedure TSoLActionsEditor.RefreshActionsList;
var
  i: Integer;
  Ai,Ci: Integer;
begin
  RefreshCategoriesList;
  Ai := lbActions.ItemIndex;
  if lbCategories.ItemIndex = -1
     then lbCategories.ItemIndex := 0;

  Ci := lbCategories.ItemIndex;
  lbActions.Clear;
  for i:=0 to FSoLActionList.ActionCount-1 do
    begin
    if (lbCategories.Items[Ci] = FSoLActionList.Actions[i].Category)
       or (lbCategories.Items[Ci] = '(All Actions)')
       then lbActions.Items.Add(FSoLActionList.Actions[i].Name + ' <' + TAction(FSoLActionList.Actions[i]).Caption + '>');
    end;
  if Ai < lbActions.Items.Count
     then lbActions.ItemIndex := Ai;
UpdateSpeedBar;
end;

procedure TSoLActionsEditor.RefreshCategoriesList;
var
  i: Integer;
  Index: Integer;
begin
  Index := lbCategories.ItemIndex;
  lbCategories.Clear;
  lbCategories.Items.Add(srNone);
  for i:=0 to FSoLActionList.ActionCount-1 do
    begin
    if lbCategories.Items.IndexOf(FSoLActionList.Actions[i].Category) = -1
       then lbCategories.Items.Add(FSoLActionList.Actions[i].Category);
    end;
  if lbCategories.Items.Count > 1
     then lbCategories.Items.Add('(All Actions)');
  if Index < lbCategories.Items.Count
     then lbCategories.ItemIndex := Index;

end;

// SpeedBar and Buttons ----------------------------------------------------------------
procedure TSoLActionsEditor.UpdateSpeedBar;
begin
tbUp.Enabled := (lbActions.ItemIndex > 0);
tbDown.Enabled := (lbActions.ItemIndex < (lbActions.Items.Count-1));
tbDelete.Enabled := (lbActions.ItemIndex > -1);
tbLoadFrom.Enabled := (MenuLoadFrom.Items[0].Visible = True);
end;

procedure TSoLActionsEditor.tbNewClick(Sender: TObject);
var
ASolAction: TSoLAction;
begin
ASoLAction := TSoLAction(TheDesigner.CreateComponent(TSoLAction,nil,0,0,0,0));
//ASoLAction := TSoLAction.Create(Self); //Keep for Test purpose
ASoLAction.ActionList := FSoLActionList;
ASoLAction.Category := srNone;
lbActions.Items.Add(ASoLAction.Caption);
lbActions.ItemIndex := FSoLActionList.ActionCount-1;
RefreshActionsList;
TheDesigner.SelectComponent(ASoLAction);
TheDesigner.Modified
end;

procedure TSoLActionsEditor.lbActionsClick(Sender: TObject);
begin
if lbActions.ItemIndex >=0
   then TheDesigner.SelectComponent(FSoLActionList.Actions[lbActions.ItemIndex]);///
UpdateSpeedBar;
end;

procedure TSoLActionsEditor.tbDeleteClick(Sender: TObject);
var
  Index: Integer;
begin
  Index := lbActions.ItemIndex;
  if Index >= 0 then
    begin
    FSoLActionList.Actions[Index].Free;
    if Index = lbActions.Items.Count-1 then Dec(Index);
    RefreshActionsList;
    lbActions.ItemIndex := Index;
    TheDesigner.Modified;
    end;
UpdateSpeedBar;
end;

procedure TSoLActionsEditor.tbUpClick(Sender: TObject);
var
I : Integer;
begin
if lbActions.ItemIndex > 0
   then begin
   I := lbActions.ItemIndex-1;
   lbActions.Items.Move(lbActions.ItemIndex,I);
   lbActions.ItemIndex := I;
   end;
UpdateSpeedBar;
end;

procedure TSoLActionsEditor.tbDownClick(Sender: TObject);
var
I : Integer;
begin
if (lbActions.ItemIndex < (lbActions.Items.Count-1)) and (lbActions.ItemIndex > -1)
   then begin
   I := lbActions.ItemIndex+1;
   lbActions.Items.Move(lbActions.ItemIndex,I);
   lbActions.ItemIndex := I;
   end;
UpdateSpeedBar;
end;

procedure TSoLActionsEditor.MenuItemClick(Sender: TObject);
var
ASolAction: TSoLAction;
AL: TActionList;
SenderName: String;
i: Integer;
begin
SenderName := TMenuItem(Sender).Caption;
if Pos('.',SenderName) = 0
   {$IFDEF Delphi6}
   then SenderName := TheDesigner.Root.Name + '.' + SenderName;
   {$ELSE}
   then SenderName := TheDesigner.Form.Name + '.' + SenderName;
   {$ENDIF}
AL := FindActionList(SenderName);
if AL <> nil
   then begin
   for i := 0 to AL.ActionCount-1 do
       begin
       ASoLAction := TSoLAction(TheDesigner.CreateComponent(TSoLAction,nil,0,0,0,0));
       ASoLAction.Assign(TAction(AL.Actions[i]));
       if ASoLAction.Category = ''
          then ASoLAction.Category := srNone;
       ASoLAction.ActionList := FSoLActionList;
       lbActions.Items.Add(ASoLAction.Caption);
       lbActions.ItemIndex := FSoLActionList.ActionCount-1;
       TheDesigner.SelectComponent(ASoLAction);
       end;
   end;
   RefreshActionsList;
   TheDesigner.Modified
end;

// ------------------------------------------------------------------------------
// TSoLCustomMemDataSharing.TargetPath Property editor
// ------------------------------------------------------------------------------
Function TSoLTargetNameEditor.GetAttributes: TPropertyAttributes;
Begin
  Result:= [paDialog];
End;

Procedure TSoLTargetNameEditor.SetValue(const Value: string);
Begin
if GetComponent(0) is TSoLCustomMemDataSharing then
  Begin
    inherited SetValue(Value);
    Modified;
  End;
End;

procedure TSoLTargetNameEditor.Edit;
var
DlgChoosePath : TOpenDialog;
Filter            : String;
Begin
   DlgChoosePath := TOpenDialog.Create(Nil);
   DlgChoosePath.FilterIndex:=1;
   DlgChoosePath.DefaultExt:='exe';
   DlgChoosePath.DefaultExt:= Filter;
   Filter:='Programs (*.exe)|*.exe';
   Filter:=Filter+'|All files (*.*)|*.*';
   DlgChoosePath.Title:='Select SoL Manager.exe :';
   DlgChoosePath.Options:=[ofFileMustExist,ofPathMustExist,ofHideReadOnly];
   DlgChoosePath.Filter :=Filter;
   if DlgChoosePath.Execute then SetStrValue(DlgChoosePath.FileName);
   DlgChoosePath.Free;
   Modified;
End;


// ------------------------------------------------------------------------------
// SoLAccessManager Editor ------------------------------------------------------
// ------------------------------------------------------------------------------
procedure TSoLAccessManagerEditor.ShowSoLAccessManagerEditor;
var
i: Integer;
SoLEd: TForm;
St: TStaticText;
Lb: TListBox;
TheDesigner: TFormDesigner;
begin
    SoLEd := TForm.Create(Application);
Try
    TheDesigner := Self.Designer;
    {$IFDEF Delphi6}
    SoLEd.Caption := TheDesigner.Root.Name + '.' + TSoLAccessManager(Component).Name;
    {$ELSE}
    SoLEd.Caption := TheDesigner.Form.Name + '.' + TSoLAccessManager(Component).Name;
    {$ENDIF}
    SoLEd.BorderStyle := bsDialog;
    SoLEd.Height := 250;
    SoLEd.Width := 150;
    St := TStaticText.Create(SolEd);
    St.Parent := SoLEd;
    St.Align := alTop;
    St.Caption := ' SoLActionsList linked to :';
    St.Color := cl3DLight;
    Lb := TListBox.Create(SoLEd);
    Lb.Parent := SoLEd;
    Lb.Align := AlClient;
    Lb.Items.Clear;
    Lb.Sorted := True;
    {$IFDEF Delphi6}
    for i := 0 to TheDesigner.Root.ComponentCount - 1 do
    if (TheDesigner.Root.Components[i] is TSoLActionList)
       and (TSoLActionList(TheDesigner.Root.Components[i]).AccessManager.Name = TSoLAccessManager(Component).Name)
         then Lb.Items.Add(TSoLActionList(TheDesigner.Root.Components[i]).Name);
    {$ELSE}
    for i := 0 to TheDesigner.Form.ComponentCount - 1 do
    if (TheDesigner.Form.Components[i] is TSoLActionList)
       and (TSoLActionList(TheDesigner.Form.Components[i]).AccessManager.Name = TSoLAccessManager(Component).Name)
         then Lb.Items.Add(TSoLActionList(TheDesigner.Form.Components[i]).Name);
   {$ENDIF}
    SoLEd.ShowModal;
Finally
    SoLEd.Free;
end;
end;

initialization
// seems necessary to complete the registerNoIcon procedure
RegisterClass(TSoLAction);
end.



